-- Filename          : tb_tmp.vhd
-- Modelname         : TB_COMMUTATOR_INTERFACECOMMUTATOR_INTERFACE
-- Title             :
-- Purpose           :
-- Author(s)         : root
-- Comment           :
-- Assumptions       :
-- Limitations       :
-- Known errors      :
-- Specification ref :
-- ------------------------------------------------------------------------
-- Modification history:
-- ------------------------------------------------------------------------
-- Version  | Author | Date       | Changes made
-- ------------------------------------------------------------------------
-- 1.0      | root | 09.06.2006 | inital version


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity TB_COMMUTATOR_INTERFACE is	--COMMUTATOR_INTERFACE is
end TB_COMMUTATOR_INTERFACE;		--COMMUTATOR_INTERFACE;

architecture BEH of TB_COMMUTATOR_INTERFACE is		--COMMUTATOR_INTERFACE is

   component COMMUTATOR_INTERFACE			--COMMUTATOR_INTERFACE
      port(HALL_POSITION     : in std_logic_vector ( 2 downto 0 );
           ROTATION_DIR      : in std_logic ;
           COMMUTATION_OUT   : out std_logic_vector ( 5 downto 0 ) );

   end component;


   --constant PERIOD : time := 10 ns;

   signal W_HALL_POSITION     : std_logic_vector ( 2 downto 0 );
   signal W_ROTATION_DIR      : std_logic ;
   signal W_COMMUTATION_OUT   : std_logic_vector ( 5 downto 0 ) ;

begin

   DUT : COMMUTATOR_INTERFACE				--COMMUTATOR_INTERFACE
      port map(HALL_POSITION     => W_HALL_POSITION,
               ROTATION_DIR      => W_ROTATION_DIR,
               COMMUTATION_OUT   => W_COMMUTATION_OUT);

   --???? <= not ???? after PERIOD/2;

   STIMULI : process
   begin
      W_HALL_POSITION     <= (others => '0');
      W_ROTATION_DIR      <= '1';

	while (true) loop
	
		W_HALL_POSITION <= "100";
		wait for 1 ms;

		W_HALL_POSITION <= "110";
		wait for 1 ms;

		W_HALL_POSITION <= "010";
		wait for 1 ms;

		W_HALL_POSITION <= "011";
		wait for 1 ms;

		W_HALL_POSITION <= "001";
		wait for 1 ms;

		W_HALL_POSITION <= "101";
		wait for 1 ms;
	end loop;

--      wait for PERIOD;
      wait;
   end process STIMULI;

end BEH;

--configuration CFG_TB_COMMUTATOR_INTERFACE of TB_COMMUTATOR_INTERFACE is	-- COMMUTATOR_INTERFACE		COMMUTATOR_INTERFACE
--   for BEH
--   end for;
--end CFG_TB_COMMUTATOR_INTERFACE;				--COMMUTATOR_INTERFACE;