library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---------------------------------------------
package hall_definitions is
	--constant cpu_freq : integer := 32768;	-- Usikker p om dette gr. Men m ha noe p 32bit.
	--constant cpu_freq : std_logic_vector(14 downto 0) := "111111111111111";-- Feil!! "100000000000000"; -- Noen enklere mte  initialisere denne p?
	
	constant freq_div_6 : std_logic_vector(12 downto 0) := "1010101010101"; -- 5461
	--constant noise_filter : integer := 0; -- Hvor mange bit som neglesjeres i hastighet fr nytt interrupt genereres.
	
	--constant counter_width : integer := 9;
end package;
---------------------------------------------

package definitions is

	constant m1 : integer := 0;
	constant m2 : integer := 1;
	constant m3 : integer := 2;
	constant m4 : integer := 3;
	constant m5 : integer := 4;

	--constant freq_div_6 : std_logic_vector(12 downto 0) := "1010101010101"; -- 5461
	constant counter_width : integer := 9;

	
	-- data_width kan reduseres til 12 bit, basert p at 5461/2 = 2730,5 er strste forekommende output.
	-- Dette ville gjre 2^12 = 4096 tilstrekkelig. men ikke generelt. Teller vil antakelig bli endret.
	
	
	-- jeg lurer faktisk p om divisjonen gir kraftig overflow ved hye hastigheter, fordi 13 er for lavt.
	-- Nei, s lenge div_6 utfres p konstanten, s skal det bre!
	constant data_width 	: integer := 12;	-- Brukes i RPM_estimator, og divisjonskrets.	-- Endret denne fra 12 til 13 for  f kompilert.
	constant speed_width 	: integer := 9;	-- Bruker 13 bit for  spare ressurser i FPGA. Svaret blir aldri strre enn 13 bit.
  
  	constant noise_filter : integer := 0; -- Hvor mange bit som neglesjeres i hastighet fr nytt interrupt genereres.
	constant off_on_delay	: integer := 1000;	-- Definerer kommuteringsforsinkelsen. Viktig!!! Aner ikke hva denne br vre enn.
	
end package;